(* ******************************************************************** *)
(*  									*)
(* 	Project		: UniForM					*)
(*  	Author 		: B.Wolff					*)
(*  	Affiliation 	: University of Bremen, 			*)
(*			  Bremen Institute of Safe Systems (BISS)	*)
(*   	This file	: installation file for isabelle toolkit        *)
(*			  (misc. functionality for interfaces &         *)
(*			  central theories for trafo-development)       *)
(*  									*)
(*  	$Date: 1997/04/23 09:55:34 $					*)
(*      $Revision: 1.6 $						*)
(*  									*)
(*  ******************************************************************* *)

(* This script is used both for the generation of "Bremen's HOL" and
   the overall check of all elements in the isa_toolkit suite.
   The distinguishing variable is the following. When CHECK is on,
   all parts were loaded and ida-doc-generation started. 
   Otherwise only basic theories were loaded, no doc's generated but
   a HOL created at the very end (which will be situated in ../bin)
 *)
val CHECK = false;

cd "thy";
use "root.sml";
cd "..";

cd "ida";
use "root.sml";
cd "..";

(* does not work perfectly. sml-stack corrupted in produced image.
   must be done by hand and  corrected externally ...
if not CHECK then
   ( cd "../bin";
     xML "HOL" "Bremen's HOL (sml109 + Isabelle94-7 + prelude + Arith + ida)")
else ();
*)
