(* ***************************************************************************
 
   $Source: /home/uniform/rep/isa_gui/tas/config.sig,v $
 
   Configurations specific for TAS 
   
   $Date: 1997/08/06 17:06:05 $
   $Revision: 1.4 $
   Author: cxl (Last modification by $Author: cxl $)

   (C) 1997, Bremen Institute for Safe Systems, Universitaet Bremen
 
  ************************************************************************** *)

signature TASCONF = 
    sig
	include GENCONF
	val TasPath      : unit-> string
	val iconPath     : unit-> string
	val examplesPath : unit-> string
	val tmpPath      : unit-> string
	val graphicsURL  : unit-> string

	val tasWinXY   : int* int

	val trafosHere : TkTypes.Coord 
	val moreTrafos : TkTypes.AnchorKind

	val substsHere : TkTypes.Coord 
	val moreSubsts : TkTypes.AnchorKind

	val devsHere   : TkTypes.Coord 
	val moreDevs   : TkTypes.AnchorKind

	val specsHere  : TkTypes.Coord
	val moreSpecs  : TkTypes.AnchorKind

    end
    
