
Segs = NatList +

consts

  mss		:: "nat list => nat" 
  segs		:: "'a list => 'a list list"

  max_f		:: "[('a => nat), 'a, 'a] => 'a"
  allp		:: "[('a => bool), 'a list] => bool"
  somep		:: "[('a => bool), 'a list] => bool"
  maxp		:: "[('a => bool), 'a list] => 'a list"

defs

  segs_def	"segs xs == foldl (op @) [] (map tails (inits xs))"
     
  mss_def	"mss xs == foldl natmax 0 (map (foldl (op +) 0) (segs xs))"
  
  allp_def	"allp p xs == foldl (op &) True (map p xs)"
 
  somep_def	"somep p xs == foldl (op |) False (map p xs)"

  max_f		"max_f f a b == if f b <= f a then a else b"

  maxp_def	"maxp p xs == foldl (max_f length) [] (filter (allp p) (segs xs))"

end
