
val defS = [Fmap.fmzero_def,Fmap.fmmk_def,Fmap.lkup_def,Fmap.dom_def,Fmap.codom_def,Fmap.ovwr_def];



goal Fmap.thy "dom({|}) = {}";
by(rewrite_goals_tac [Fmap.dom_def,Fmap.fmzero_def]);
by(cut_facts_tac Fmap.runS.intrs 1);
by(res_inst_tac [("t","Rep_Fmap(Abs_Fmap({}))")] ssubst 1);
br Fmap.Abs_Fmap_inverse 1;
ba 1;
by(simp_tac set_ss 1);
val dom_mt = result();

goal Fmap.thy "codom({|}) = {}";
by(rewrite_goals_tac [Fmap.codom_def,Fmap.fmzero_def]);
by(cut_facts_tac Fmap.runS.intrs 1);
by(res_inst_tac [("t","Rep_Fmap(Abs_Fmap({}))")] ssubst 1);
br Fmap.Abs_Fmap_inverse 1;
ba 1;
by(simp_tac set_ss 1);
val dom_mt = result();


goal Fmap.thy "dom({|x:=X|}) = {x}";
by(rewrite_goals_tac [Fmap.dom_def,Fmap.fmmk_def]);
by(res_inst_tac [("t","Rep_Fmap(Abs_Fmap(?S))")] ssubst 1);
br Fmap.Abs_Fmap_inverse 1;
br (hd(tl(Fmap.runS.intrs))) 1;
by(cut_facts_tac Fmap.runS.intrs 1);
ba 1;
by(ALLGOALS (simp_tac (set_ss addsimps [image_insert])));
by(simp_tac prod_ss 1);
val dom_upd = result();



goal Fmap.thy "codom({|x:=X|}) = {X}";
by(rewrite_goals_tac [Fmap.codom_def,Fmap.fmmk_def]);
by(res_inst_tac [("t","Rep_Fmap(Abs_Fmap(?S))")] ssubst 1);
br Fmap.Abs_Fmap_inverse 1;
br (hd(tl(Fmap.runS.intrs))) 1;
by(cut_facts_tac Fmap.runS.intrs 1);
ba 1;
by(ALLGOALS (simp_tac (set_ss addsimps [image_insert])));
by(simp_tac prod_ss 1);
val codom_upd = result();

(*

val prems = goal Fmap.thy "X : runS(A) ==> (x : fst `` X)-->(?!y. (x,y) : X)";
br Fmap.runS.induct 1;
by(cut_facts_tac prems 1);
ba 1;
by(ALLGOALS (asm_simp_tac (set_ss addsimps (Fmap.runS.intrs @ [Fmap.Abs_Fmap_inverse]))));
by(CASE_DISTINCT 1 ["x= fst(a)"] []);
(* CASE: x = fst(a)  *)
(* by(ALLGOALS (asm_full_simp_tac (set_ss))); *)
by(asm_full_simp_tac (set_ss addsimps [image_insert]) 1);
(* SINCE "(%y. (fst(a), y) : b) = (% y. False)" *)
by(res_inst_tac [("t","%y.(fst(a), y) : b")] ssubst 1);
by(subgoal_tac "(%y. (fst(a), y) : b) = (% y. False)" 1);
ba 1;
(* ENDSINCE *)
by(asm_simp_tac (set_ss) 2);
by(res_inst_tac [("a","snd(a)")] ex1I 2);
br (surjective_pairing RS sym) 2;
by(res_inst_tac [("t","a")] ssubst 2);
br sym 2;
ba 2;
by (simp_tac prod_ss 2);
(* PROVE SINCE *)
br ext 1;
br notnotD 1;
by(asm_simp_tac (HOL_ss) 1);
br notI 1;
by(subgoal_tac "fst(a) : fst `` b" 1);
br fst_imageI 2;
ba 2;
be notE 1;
ba 1;

(* CASE: x ~= fst(a)  *)
(* SINCE "(%y. (x, y) = a) = (% y. False)" *)
by(res_inst_tac [("t","%y.(x, y) = a")] ssubst 1);
by(subgoal_tac "(%y. (x, y) = a) = (% y. False)" 1);
ba 1; (*ENDSINCE *)
(* SINCE "(x : fst `` insert(a, b)) = (x : fst `` b)" *)
by(res_inst_tac [("t","x : fst `` (insert a b)")] ssubst 2);
by(subgoal_tac "(x : fst `` (insert a  b)) = (x : fst `` b)" 2);
ba 2; (*ENDSINCE *)
(* Induction Step *)
by(asm_simp_tac (HOL_ss) 3);
(* PROVE SINCE 1 *)
br ext 1;
by(res_inst_tac [("t","a")] ssubst 1);
by (asm_simp_tac prod_ss 1);
by(res_inst_tac [("t","a")] ssubst 1);
br surjective_pairing 1;
br notnotD 1;
by(asm_simp_tac (HOL_ss) 1);
br notI 1;
by( (asm_full_simp_tac (prod_ss))1);
(* PROVE SINCE 2 *)
by(rewrite_goals_tac [insert_def]);
by(simp_tac (set_ss addsimps [image_Un]) 1);
by(res_inst_tac [("t","x : fst `` {x. x = a}")] ssubst 1);
by(subgoal_tac "(x : fst `` {x. x = a}) = False" 1);
ba 1;
by(asm_simp_tac (HOL_ss) 2);
by(rewrite_goals_tac [image_def]);
by(step_tac set_cs 1);
val right_unique = result();


(*




val insert_not_mt = assume_ax Set.thy " (insert a A) ~= {}";

val prems = goal Fmap.thy 
"[| X : runS(A); Y : runS(A)|] ==> 					\
\	((fst `` X = fst `` Y) &					\
\     	(!x.  ((x : fst `` X) & ((@y. (x, y) : X) = (@y. (x, y) : Y)))))\
\   --> X = Y";
by (res_inst_tac [("x","X")] Fmap.runS.induct 1);
by(cut_facts_tac prems 1);
ba 1;
by(ALLGOALS (simp_tac (set_ss )));
by (res_inst_tac [("x","Y")] Fmap.runS.induct 1);
by(cut_facts_tac prems 1);
ba 1;
by(ALLGOALS (simp_tac (set_ss )));
(* SINCE fst `` insert(a, b) = {} = False *)
by(res_inst_tac [("t","fst `` (insert a b) = {}")] ssubst 1);
by(subgoal_tac "(fst `` (insert a b) = {}) = False" 1);
ba 1;
by(ALLGOALS (simp_tac (set_ss )));

br notnotD 1;
by(simp_tac (HOL_ss) 1);
by(simp_tac (set_ss addsimps [insert_not_mt,image_insert]) 1);

(* CASE_DISTINCT 1 "x = aa", without simplifikation);

by(cut_facts_tac [True_or_False] 1);
by(etac disjE 1);
by(res_inst_tac [("t","a = aa")] ssubst 1);
ba 1;

(* SINCE "a = aa" *)
by(res_inst_tac [("t","a")] ssubst 1);
by(subgoal_tac "a = aa" 1);
ba 1; (*ENDSINCE *)
br eqTrueE 1;
ba 1;

(* So. Induction step seems to be provable:

       [| 
          fst `` b = fst `` Y &
          (! x. x : fst `` b & (@y. <x, y> : b) = (@y. <x, y> : Y)) --> b = Y;
          fst(aa) ~: fst `` ba; a = aa|] ==>

       fst `` insert(aa, b) = fst `` insert(aa, ba) &
       (! x. x : fst `` insert(aa, b) &
             (@y. <x, y> = aa | <x, y> : b) =
             (@y. <x, y> = aa | <x, y> : ba)) -->
       insert(aa, b) = insert(aa, ba)


But what about the other way round:

       [| b : runS(A);
          fst `` b = fst `` Y &
          (! x. x : fst `` b & (@y. <x, y> : b) = (@y. <x, y> : Y)) -->
          b = Y;
          fst(a) ~: fst `` b; ba : runS(A);
          fst `` insert(a, b) = fst `` ba &
          (! x. x : fst `` insert(a, b) &
                (@y. <x, y> = a | <x, y> : b) = (@y. <x, y> : ba)) -->
          insert(a, b) = ba;
          fst(aa) ~: fst `` ba; a = aa = False |] ==>
       fst `` insert(a, b) = fst `` insert(aa, ba) &
       (! x. x : fst `` insert(a, b) &
             (@y. <x, y> = a | <x, y> : b) =
             (@y. <x, y> = aa | <x, y> : ba)) -->
       insert(a, b) = insert(aa, ba)



>>>>>>>>>>>>>

by(rewrite_goals_tac [Fmap.dom_def,Fmap.fmzero_def]);


>>>>>>>>>>>>>




val prems = goal Fmap.thy
"[|P({|}) ; !x y B.(P(B) & x ~: dom(B)) --> P({|x := y |}<+ B )|] ==> P(A)";
by(res_inst_tac [("t","A")] subst 1);
br Fmap.Rep_Fmap_inverse 1;
by (res_inst_tac [("x","Rep_Fmap(A)")] Fmap.runS.induct 1);
br Fmap.Rep_Fmap 1;
by(fold_goals_tac [Fmap.fmzero_def]);
by(cut_facts_tac prems 1);
ba 1;

>>>>>>>>>>>>>

val prems = goal Fmap.thy
"x ~: dom(B) ==> Rep_Fmap({|x := y|} <+ B) = insert (x,y) (Rep_Fmap B)";


val prems = goal Fmap.thy
"Rep_Fmap({|x := y|} <+ B) = insert(x,y) (Rep_Fmap B) - {(x,B^x)})";



>>>>>>>>>>>>>


"[| ?x : lunS(?A); ?P({});
      !!a b.
         [| a : ?A; b : lunS(?A); ?P(b); fst(a) ~: fst `` b |] ==>
         ?P(insert(a, b)) |] ==> ?P(?x)"



val prems = goal Fmap.thy "A <+ {|} = A";
by(rewrite_goals_tac defS);
by(ALLGOALS (asm_simp_tac (set_ss addsimps (Fmap.runS.intrs @ [Fmap.Abs_Fmap_inverse]))));
br select_equality 1;
by(ALLGOALS (asm_simp_tac (set_ss addsimps (Fmap.runS.intrs @ [Fmap.Abs_Fmap_inverse]))));
be conjE 1;


lunS

*)
*)
*)


*)
