(* ***************************************************************************
 
   $Source: /home/uniform/rep/isa_gui/isa_win/config.sml,v $
    
   IsaWin Configurations.
   
   $Date: 1997/08/08 08:40:56 $
   $Revision: 1.15 $
   Author: cxl (Last modification by $Author: cxl $)

   (C) 1996, Bremen Institute for Safe Systems, Universitaet Bremen
 
  ************************************************************************** *)


structure IsaConfNormal : ISAWINCONF = 

    struct

	open TkTypes

	fun IsaWinPath() = SmlTk.getSrcPath()^"../../isa_gui/isa_win/"

	val width=         700
	val height=        350
	val background=    Grey
	val iconNameFont=  SansSerif[Small]
	val iconNameWidth= 60
	fun iconPath()=    IsaWinPath()^"icons/small"
	fun trashcanIcon()=  Icons.getIcon(SmlTk.getSrcPath()^"toolkit/icons",
					   "trashcan.gif")
	val trashcanCoord= (650, 250)
	val moveOpaque=    true
	val oneWindow=     false
	val wsHeight=      350
	val wsWidth=       700

	val delta=         70

	val isaWinXY=      (10, 10)

	val wsXY=          SOME (10, 420)
	fun wsTitle nm =   "IsaWin Proof: "^nm

	val wsButtonFont=  SansSerif []

	val ttFont=        Typewriter[]

	structure uw =
            struct
                val msgWidth=      200
		val msgFont=       Normalfont[]		    
		val buttonWidth=   10
		val buttonFont=    SansSerif []
		val enterTextFont= Typewriter[]
		fun errorIconFilenm()=   (SmlTk.getSrcPath())^
		                                   "toolkit/images/stop.gif"
		fun warningIconFilenm()= (SmlTk.getSrcPath())^
		                                   "toolkit/images/warning.gif"
            end

	val thmsHere = (20, 20)
	val simpsHere= (20, 20)
	val csHere=    (20, 20)
	val thysHere=  (40,150)
	val substHere= (50, 150)
	val txtHere= (190, 150)
	val prfsHere= (100,100)
	
end

    
