(* ***************************************************************************
 
   $Source: /home/uniform/rep/isa_gui/tas/config.sml,v $
    
   TAS Configurations.
   
   $Date: 1997/08/13 11:49:07 $
   $Revision: 1.16 $
   Author: cxl (Last modification by $Author: cxl $)

   (C) 1996, Bremen Institute for Safe Systems, Universitaet Bremen
 
  ************************************************************************** *)



functor TasConfNormal (val examples_dir : string) =
  
    struct

	open TkTypes
     
        (*  TAS is here: *)
	fun TasPath() =    SmlTk.getSrcPath()^"../../isa_gui/tas/"

	fun iconPath() =   TasPath()^"icons/small"

	fun examplesPath()= TasPath()^(examples_dir)
	fun tmpPath()     = TasPath()^"examples/"
	fun graphicsURL() = "file:"^(TasPath())^"icons/"

	val width=         700
	val height=        350
	val background=    Grey
	val iconNameFont=  SansSerif [Small]
	val iconNameWidth= 60
	fun trashcanIcon()=  Icons.getIcon(SmlTk.getSrcPath()^"toolkit/icons",
					   "trashcan.gif")
	val trashcanCoord= (650, 250)
	val moveOpaque=    true
	val oneWindow=     false
	val wsHeight=      350
	val wsWidth=       700
	fun wsTitle nm =   "UniForM Transformation Application System " ^ nm
	val ttFont=        Typewriter[]

	val delta=         70

	val tasWinXY =     (10, 10)
	val wsXY =         SOME (10, 420)


	(* initial placements *)
	val trafosHere = (10,200)
	val moreTrafos = East
	    
	val substsHere = (500,10)
	val moreSubsts = West
	    
	val devsHere = (10,10)
	val moreDevs = East

	val specsHere = (10, 10)
	val moreSpecs = East


	structure uw =
            struct
                val msgWidth=      200
		val msgFont=       Normalfont[]
		val buttonWidth=   10
		val buttonFont=    SansSerif[]
		val enterTextFont= Typewriter[]
		fun errorIconFilenm()=   (SmlTk.getSrcPath())^
		                                   "toolkit/images/stop.gif"
		fun warningIconFilenm()= (SmlTk.getSrcPath())^
		                                   "toolkit/images/warning.gif"
            end

	


end
